import { Config, Inject, InjectClient, Provide } from '@midwayjs/core';
import { JwtService } from '@midwayjs/jwt';
import { Context } from '@midwayjs/koa';
import { get } from 'lodash';
import { LoginError } from '../error/login.error';

@Provide()
export class SingleSignOnService {
  @Inject()
  ctx: Context;
  @Inject()
  jwtService: JwtService;
  async index() {
    let user;
    const token: any = get(this.ctx.request, 'header.token');
    if (token) {
      const data = this.jwtService.decodeSync(token);
      if (data) user = data;
    }
    if (!user) throw new LoginError('TEST');
  }
}
